// zeros.js

Bigint._getStringZeros = function( nZeros ) {
	var myTable = [ "", "0", "00", "000", "0000", "00000", "000000", "0000000", "00000000", "000000000" ];
	if( nZeros < 0 || nZeros !== Math.floor( nZeros ) || nZeros > 16777216 )
		return Bigint._error( "_getStringZeros" , "Input bad or too big: " + nZeros );
	if( nZeros < 10 ) return myTable[ nZeros ];

	var strBinary = nZeros.toString( 2 );
	var nLastIndex = strBinary.length - 1;
	var strResult = "";
	var strWork = "0";
	for( var i = 0; ; i++ ) {
		if( strBinary.charAt( nLastIndex - i ) === "1" ) strResult += strWork;
		if( i === nLastIndex ) break;
		strWork += strWork;
	}


	return strResult;
}

///////////////////////////////////////////////////////////////////
//
// Padding ( number -> string )
//
///////////////////////////////////////////////////////////////////

Bigint._padding1 = function( n ) {
	var strNumber = String( n );
	if( strNumber.length === 1 ) return strNumber;
	else return Bigint._error("_padding","bad input: " + n );
}

Bigint._padding2 = function( n ) {
	var strNumber = String( n );
	switch( strNumber.length ) {
		case 2: return       strNumber;
		case 1: return "0" + strNumber;
		default: return Bigint._error("_padding","bad input: " + n );
	}
}

Bigint._padding3 = function( n ) {
	var strNumber = String( n );
	switch( strNumber.length ) {
		case 3: return        strNumber;
		case 2: return "0"  + strNumber;
		case 1: return "00" + strNumber;
		default: return Bigint._error("_padding","bad input: " + n );
	}
}

Bigint._padding4 = function( n ) {
	var strNumber = String( n );
	switch( strNumber.length ) {
		case 4: return         strNumber;
		case 3: return "0"   + strNumber;
		case 2: return "00"  + strNumber;
		case 1: return "000" + strNumber;
		default: return Bigint._error("_padding","bad input: " + n );
	}
}

Bigint._padding5 = function( n ) {
	var strNumber = String( n );
	switch( strNumber.length ) {
		case 5: return            strNumber;
		case 4: return "0"    + strNumber;
		case 3: return "00"   + strNumber;
		case 2: return "000"  + strNumber;
		case 1: return "0000" + strNumber;
		default: return Bigint._error("_padding","bad input: " + n );
	}
}

Bigint._padding6 = function( n ) {
	var strNumber = String( n );
	switch( strNumber.length ) {
		case 6: return           strNumber;
		case 5: return "0"     + strNumber;
		case 4: return "00"    + strNumber;
		case 3: return "000"   + strNumber;
		case 2: return "0000"  + strNumber;
		case 1: return "00000" + strNumber;
		default: return Bigint._error("_padding","bad input: " + n );
	}
}

Bigint._padding7 = function( n ) {
	var strNumber = String( n );
	switch( strNumber.length ) {
		case 7: return            strNumber;
		case 6: return "0"      + strNumber;
		case 5: return "00"     + strNumber;
		case 4: return "000"    + strNumber;
		case 3: return "0000"   + strNumber;
		case 2: return "00000"  + strNumber;
		case 1: return "000000" + strNumber;
		default: return Bigint._error("_padding","bad input: " + n );
	}
}

Bigint._padding8 = function( n ) {
	var strNumber = String( n );
	switch( strNumber.length ) {
		case  8: return             strNumber;
		case  7: return "0"       + strNumber;
		case  6: return "00"      + strNumber;
		case  5: return "000"     + strNumber;
		case  4: return "0000"    + strNumber;
		case  3: return "00000"   + strNumber;
		case  2: return "000000"  + strNumber;
		case  1: return "0000000" + strNumber;
		default: return Bigint._error("_padding","bad input: " + n );
	}
}
Bigint._padding9 = function( n ) {
	var strNumber = String( n );
	switch( strNumber.length ) {
		case  9: return              strNumber;
		case  8: return "0"        + strNumber;
		case  7: return "00"       + strNumber;
		case  6: return "000"      + strNumber;
		case  5: return "0000"     + strNumber;
		case  4: return "00000"    + strNumber;
		case  3: return "000000"   + strNumber;
		case  2: return "0000000"  + strNumber;
		case  1: return "00000000" + strNumber;
		default: return Bigint._error("_padding","bad input: " + n );
	}
}
Bigint._padding10 = function( n ) {
	var strNumber = String( n );
	switch( strNumber.length ) {
		case 10: return               strNumber;
		case  9: return "0"         + strNumber;
		case  8: return "00"        + strNumber;
		case  7: return "000"       + strNumber;
		case  6: return "0000"      + strNumber;
		case  5: return "00000"     + strNumber;
		case  4: return "000000"    + strNumber;
		case  3: return "0000000"   + strNumber;
		case  2: return "00000000"  + strNumber;
		case  1: return "000000000" + strNumber;
		default: return Bigint._error("_padding","bad input: " + n );
	}
}

Bigint._padding11 = function( n ) {
	var strNumber = String( n );
	switch( strNumber.length ) {
		case 11: return                strNumber;
		case 10: return "0"          + strNumber;
		case  9: return "00"         + strNumber;
		case  8: return "000"        + strNumber;
		case  7: return "0000"       + strNumber;
		case  6: return "00000"      + strNumber;
		case  5: return "000000"     + strNumber;
		case  4: return "0000000"    + strNumber;
		case  3: return "00000000"   + strNumber;
		case  2: return "000000000"  + strNumber;
		case  1: return "0000000000" + strNumber;
		default: return Bigint._error("_padding","bad input: " + n );
	}
}

Bigint._padding12 = function( n ) {
	var strNumber = String( n );
	switch( strNumber.length ) {
		case 12: return                 strNumber;
		case 11: return "0"           + strNumber;
		case 10: return "00"          + strNumber;
		case  9: return "000"         + strNumber;
		case  8: return "0000"        + strNumber;
		case  7: return "00000"       + strNumber;
		case  6: return "000000"      + strNumber;
		case  5: return "0000000"     + strNumber;
		case  4: return "00000000"    + strNumber;
		case  3: return "000000000"   + strNumber;
		case  2: return "0000000000"  + strNumber;
		case  1: return "00000000000" + strNumber;
		default: return Bigint._error("_padding","bad input: " + n );
	}
}

Bigint._padding13 = function( n ) {
	var strNumber = String( n );
	switch( strNumber.length ) {
		case 13: return                  strNumber;
		case 12: return "0"            + strNumber;
		case 11: return "00"           + strNumber;
		case 10: return "000"          + strNumber;
		case  9: return "0000"         + strNumber;
		case  8: return "00000"        + strNumber;
		case  7: return "000000"       + strNumber;
		case  6: return "0000000"      + strNumber;
		case  5: return "00000000"     + strNumber;
		case  4: return "000000000"    + strNumber;
		case  3: return "0000000000"   + strNumber;
		case  2: return "00000000000"  + strNumber;
		case  1: return "000000000000" + strNumber;
		default: return Bigint._error("_padding","bad input: " + n );
	}
}

Bigint._padding14 = function( n ) {
	var strNumber = String( n );
	switch( strNumber.length ) {
		case 14: return                   strNumber;
		case 13: return "0"             + strNumber;
		case 12: return "00"            + strNumber;
		case 11: return "000"           + strNumber;
		case 10: return "0000"          + strNumber;
		case  9: return "00000"         + strNumber;
		case  8: return "000000"        + strNumber;
		case  7: return "0000000"       + strNumber;
		case  6: return "00000000"      + strNumber;
		case  5: return "000000000"     + strNumber;
		case  4: return "0000000000"    + strNumber;
		case  3: return "00000000000"   + strNumber;
		case  2: return "000000000000"  + strNumber;
		case  1: return "0000000000000" + strNumber;
		default: return Bigint._error("_padding","bad input: " + n );
	}
}

Bigint._padding15 = function( n ) {
	var strNumber = String( n );
	switch( strNumber.length ) {
		case 15: return                    strNumber;
		case 14: return "0"              + strNumber;
		case 13: return "00"             + strNumber;
		case 12: return "000"            + strNumber;
		case 11: return "0000"           + strNumber;
		case 10: return "00000"          + strNumber;
		case  9: return "000000"         + strNumber;
		case  8: return "0000000"        + strNumber;
		case  7: return "00000000"       + strNumber;
		case  6: return "000000000"      + strNumber;
		case  5: return "0000000000"     + strNumber;
		case  4: return "00000000000"    + strNumber;
		case  3: return "000000000000"   + strNumber;
		case  2: return "0000000000000"  + strNumber;
		case  1: return "00000000000000" + strNumber;
		default: return Bigint._error("_padding","bad input: " + n );
	}
}

Bigint._padding16 = function( n ) {
	var strNumber = String( n );
	switch( strNumber.length ) {
		case 16: return                     strNumber;
		case 15: return "0"               + strNumber;
		case 14: return "00"              + strNumber;
		case 13: return "000"             + strNumber;
		case 12: return "0000"            + strNumber;
		case 11: return "00000"           + strNumber;
		case 10: return "000000"          + strNumber;
		case  9: return "0000000"         + strNumber;
		case  8: return "00000000"        + strNumber;
		case  7: return "000000000"       + strNumber;
		case  6: return "0000000000"      + strNumber;
		case  5: return "00000000000"     + strNumber;
		case  4: return "000000000000"    + strNumber;
		case  3: return "0000000000000"   + strNumber;
		case  2: return "00000000000000"  + strNumber;
		case  1: return "000000000000000" + strNumber;
		default: return Bigint._error("_padding","bad input: " + n );
	}
}

Bigint._padding = [
	undefined,
	Bigint._padding1 ,
	Bigint._padding2 ,
	Bigint._padding3 ,
	Bigint._padding4 ,
	Bigint._padding5 ,
	Bigint._padding6 ,
	Bigint._padding7 ,
	Bigint._padding8 ,
	Bigint._padding9 ,
	Bigint._padding10 ,
	Bigint._padding11 ,
	Bigint._padding12 ,
	Bigint._padding13 ,
	Bigint._padding14 ,
	Bigint._padding15 ,
	Bigint._padding16
];

Bigint._paddingBigger = Bigint._padding15;

var __BIGINT_FN_PADDING = Bigint._padding[ __BIGINT_POWER ];
